//
//  ShuZiView.m
//  TextHuaShuzi
//
//  Created by zhuochunsheng on 16/6/16.
//  Copyright © 2016年 fenda. All rights reserved.
//

#import "ShuZiView.h"


@interface ShuZiView()

@property (nonatomic, assign) NSInteger numberType;

@end
@implementation ShuZiView



- (instancetype)initWithFrame:(CGRect)frame
{
    if (self = [super initWithFrame:frame]) {
    }
    return self;
}

- (instancetype)initWithFrame:(CGRect)frame withType:(NSInteger)type
{
    if (self = [super initWithFrame:frame]) {
        self.numberType = type;
    }
    return self;
}
- (void)drawRect:(CGRect)rect {
    [self.layer.sublayers makeObjectsPerformSelector:@selector(removeFromSuperlayer)];
    CGFloat width_W = rect.size.width;
    CGFloat height_H = rect.size.height;
    
    NSInteger type = self.numberType;
    switch (type) {
        case 0:
        {
            CAShapeLayer *zeroLayer = [CAShapeLayer layer];
            
            // 线的路径
            UIBezierPath *zeroPath = [UIBezierPath bezierPathWithOvalInRect:CGRectMake((width_W - 16)/2, (height_H - 28)/2, 16, 28)];
            
            // 线的特点
            zeroLayer.path = zeroPath.CGPath;
            zeroLayer.strokeColor = [UIColor blackColor].CGColor;
            zeroLayer.fillColor = [UIColor clearColor].CGColor;
            zeroLayer.lineCap = kCALineCapButt;
            zeroLayer.lineWidth = 1;
            [self.layer addSublayer:zeroLayer];
            [self addAnimationOneOnLayer:zeroLayer duration:0.5];
        }
            break;
        case 1:
        {
            CAShapeLayer *oneLayer = [CAShapeLayer layer];
            
            // 线的路径
            UIBezierPath *onePath = [UIBezierPath bezierPath];
            [onePath moveToPoint:CGPointMake(width_W/2 - 10, (height_H - 28)/2 + 6)];
            [onePath addLineToPoint:CGPointMake(width_W/2, (height_H - 28)/2)];
            [onePath addLineToPoint:CGPointMake(width_W/2, (height_H - 28)/2 + 28)];
            
            // 线的特点
            oneLayer.path = onePath.CGPath;
            oneLayer.strokeColor = [UIColor blackColor].CGColor;
            oneLayer.fillColor = [UIColor clearColor].CGColor;
            oneLayer.lineCap = kCALineCapButt;
            oneLayer.lineWidth = 1;
            [self.layer addSublayer:oneLayer];
            [self addAnimationOneOnLayer:oneLayer duration:1];
            
        }
            break;
        case 2:
        {
            CAShapeLayer *twoLayer = [CAShapeLayer layer];
            // 线的路径
            UIBezierPath *twoPath = [UIBezierPath bezierPath];
            [twoPath addArcWithCenter:CGPointMake(width_W/2, (height_H - 28)/2 + 7) radius:8 startAngle:-M_PI endAngle:M_PI/4 clockwise:YES];
            [twoPath addLineToPoint:CGPointMake(width_W/2 - 8, (height_H - 28)/2 + 26)];
            [twoPath addLineToPoint:CGPointMake(width_W/2 - 8 + 18, (height_H - 28)/2 + 26)];
            
            // 线的特点
            twoLayer.path = twoPath.CGPath;
            twoLayer.strokeColor = [UIColor blackColor].CGColor;
            twoLayer.fillColor = [UIColor clearColor].CGColor;
            twoLayer.lineCap = kCALineCapButt;
            twoLayer.lineWidth = 1;
            [self.layer addSublayer:twoLayer];
            [self addAnimationOneOnLayer:twoLayer duration:1];
        }
            break;
        case 3:
        {
            CAShapeLayer *threeLayer = [CAShapeLayer layer];
            
            // 线的路径
            UIBezierPath *threePath = [UIBezierPath bezierPath];
            [threePath addArcWithCenter:CGPointMake(width_W/2, (height_H - 28)/2 + 7) radius:7 startAngle:-M_PI endAngle:M_PI/1.8 clockwise:YES];
            [threePath addArcWithCenter:CGPointMake(width_W/2, (height_H - 28)/2 + 21) radius:8 startAngle: - M_PI/2 endAngle: M_PI clockwise:YES];
            
            // 线的特点
            threeLayer.path = threePath.CGPath;
            threeLayer.strokeColor = [UIColor blackColor].CGColor;
            threeLayer.fillColor = [UIColor clearColor].CGColor;
            threeLayer.lineCap = kCALineCapButt;
            threeLayer.lineWidth = 1;
            [self.layer addSublayer:threeLayer];
            [self addAnimationOneOnLayer:threeLayer duration:1];
        }
            break;
        case 4:
        {
            CAShapeLayer *fourLayer = [CAShapeLayer layer];
            CAShapeLayer *otherLayer = [CAShapeLayer layer];
            // 线的路径
            UIBezierPath *fourPath = [UIBezierPath bezierPath];
            [fourPath moveToPoint:CGPointMake(width_W/2 + 2, (height_H - 28)/2)];
            [fourPath addLineToPoint:CGPointMake(width_W/2 - 10, (height_H - 28)/2 + 20)];
            [fourPath addLineToPoint:CGPointMake(width_W/2 + 6, (height_H - 28)/2 + 20)];
            // 线的特点
            fourLayer.path = fourPath.CGPath;
            fourLayer.strokeColor = [UIColor blackColor].CGColor;
            fourLayer.fillColor = [UIColor clearColor].CGColor;
            fourLayer.lineCap = kCALineCapButt;
            fourLayer.lineWidth = 1;
            
            // 另一条路径
            UIBezierPath *otherPath = [UIBezierPath bezierPath];
            [otherPath moveToPoint:CGPointMake(width_W/2 + 2, (height_H - 28)/2)];
            [otherPath addLineToPoint:CGPointMake(width_W/2 + 2, (height_H - 28)/2 + 28)];
            // 路径特点
            otherLayer.path = otherPath.CGPath;
            otherLayer.strokeColor = [UIColor blackColor].CGColor;
            otherLayer.fillColor = [UIColor clearColor].CGColor;
            otherLayer.lineCap = kCALineCapButt;
            otherLayer.lineWidth = 1;
            [self.layer addSublayer:fourLayer];
            [self addAnimationOneOnLayer:fourLayer duration:0.5];
            dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.5 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
                [self.layer addSublayer:otherLayer];
                [self addAnimationOneOnLayer:otherLayer duration:0.5];
            });
        }
            break;
        case 5:
        {
            CAShapeLayer *fiveLayer = [CAShapeLayer layer];
            CAShapeLayer *otherLayer = [CAShapeLayer layer];
            
            // 线的路径
            UIBezierPath *fivePath = [UIBezierPath bezierPath];
            [fivePath moveToPoint:CGPointMake(width_W/2 - 6, (height_H - 28)/2)];
            [fivePath addLineToPoint:CGPointMake(width_W/2- 7, (height_H - 28)/2 + 12)];
            [fivePath addArcWithCenter:CGPointMake(width_W/2, (height_H - 28)/2 + 19) radius:8 startAngle: - (M_PI/5)*4 endAngle: M_PI clockwise:YES];
            
            // 另一条直接
            UIBezierPath *otherPath = [UIBezierPath bezierPath];
            [otherPath moveToPoint:CGPointMake(width_W/2 - 6, (height_H - 28)/2)];
            [otherPath addLineToPoint:CGPointMake(width_W/2 + 6, (height_H - 28)/2)];
            
            
            // 线的特点
            fiveLayer.path = fivePath.CGPath;
            fiveLayer.strokeColor = [UIColor blackColor].CGColor;
            fiveLayer.fillColor = [UIColor clearColor].CGColor;
            fiveLayer.lineCap = kCALineCapButt;
            fiveLayer.lineWidth = 1;
            [self.layer addSublayer:fiveLayer];
            [self addAnimationOneOnLayer:fiveLayer duration:0.5];
            
            // 另一条线的特点
            otherLayer.path = otherPath.CGPath;
            otherLayer.strokeColor = [UIColor blackColor].CGColor;
            otherLayer.fillColor = [UIColor clearColor].CGColor;
            otherLayer.lineCap = kCALineCapButt;
            otherLayer.lineWidth = 1;
            dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.5 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
                [self.layer addSublayer:otherLayer];
                [self addAnimationOneOnLayer:otherLayer duration:0.5];
            });
        }
            break;
        case 6:
        {
            CAShapeLayer *sixLayer = [CAShapeLayer layer];
            
            // 线的路径
            UIBezierPath *sixPath = [UIBezierPath bezierPath];
            [sixPath addArcWithCenter:CGPointMake(width_W/2, (height_H - 28)/2 + 7) radius:8 startAngle:0 endAngle: -M_PI clockwise:NO];
            [sixPath addLineToPoint:CGPointMake(width_W/2 - 8, (height_H - 28)/2 + 7 + 6)];
            [sixPath addArcWithCenter:CGPointMake(width_W/2, (height_H - 28)/2 + 7 + 11) radius:8 startAngle:M_PI endAngle:-M_PI clockwise:NO];
            
            // 线的特点
            sixLayer.path = sixPath.CGPath;
            sixLayer.strokeColor = [UIColor blackColor].CGColor;
            sixLayer.fillColor = [UIColor clearColor].CGColor;
            sixLayer.lineCap = kCALineCapButt;
            sixLayer.lineWidth = 1;
            [self.layer addSublayer:sixLayer];
            [self addAnimationOneOnLayer:sixLayer duration:1];
            
        }
            break;
        case 7:
        {
            CAShapeLayer *sevenLayer = [CAShapeLayer layer];
            
            // 线的路径
            UIBezierPath *sevenPath = [UIBezierPath bezierPath];
            [sevenPath moveToPoint:CGPointMake(width_W/2 - 8, (height_H - 28)/2 + 1)];
            [sevenPath addLineToPoint:CGPointMake(width_W/2 + 8, (height_H - 28)/2 + 1)];
            [sevenPath addLineToPoint:CGPointMake(width_W/2 - 5 , (height_H - 28)/2 + 28)];
            
            // 线的特点
            sevenLayer.path = sevenPath.CGPath;
            sevenLayer.strokeColor = [UIColor blackColor].CGColor;
            sevenLayer.fillColor = [UIColor clearColor].CGColor;
            sevenLayer.lineCap = kCALineCapButt;
            sevenLayer.lineWidth = 1;
            [self.layer addSublayer:sevenLayer];
            [self addAnimationOneOnLayer:sevenLayer duration:1];
        }
            break;
        case 8:
        {
            CAShapeLayer *eightLayer = [CAShapeLayer layer];
            CAShapeLayer *otherLayer = [CAShapeLayer layer];
            // 线的路径
            UIBezierPath *eightPath = [UIBezierPath bezierPathWithOvalInRect:CGRectMake((width_W - 14)/2, (height_H - 28)/2 + 1, 14, 12)];
            // 另外一条线的路径
            UIBezierPath *otherPath = [UIBezierPath bezierPathWithOvalInRect:CGRectMake((width_W - 16)/2, (height_H - 28)/2 + 14 -1, 16, 14)];
            
            // 线的特点
            eightLayer.path = eightPath.CGPath;
            eightLayer.strokeColor = [UIColor blackColor].CGColor;
            eightLayer.fillColor = [UIColor clearColor].CGColor;
            eightLayer.lineCap = kCALineCapButt;
            eightLayer.lineWidth = 1;
            
            // 另外一条线的特点
            otherLayer.path = otherPath.CGPath;
            otherLayer.strokeColor = [UIColor blackColor].CGColor;
            otherLayer.fillColor = [UIColor clearColor].CGColor;
            otherLayer.lineCap = kCALineCapButt;
            otherLayer.lineWidth = 1;
            [self.layer addSublayer:eightLayer];
            [self addAnimationOneOnLayer:eightLayer duration:0.5];
            dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.5 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
                [self.layer addSublayer:otherLayer];
                [self addAnimationOneOnLayer:otherLayer duration:0.5];
            });
        }
            break;
        case 9:
        {
            CAShapeLayer *nineLayer = [CAShapeLayer layer];
            
            // 线的路径
            UIBezierPath *ninePath = [UIBezierPath bezierPath];
            [ninePath moveToPoint:CGPointMake(width_W/2 + 8, (height_H - 28)/2 + 9)];
            [ninePath addArcWithCenter:CGPointMake(width_W/2, (height_H - 28)/2 + 9) radius:8 startAngle:0 endAngle:M_PI * 2 clockwise:YES];
            [ninePath addArcWithCenter:CGPointMake(width_W/2, (height_H - 28)/2 + 9 + 11) radius:8 startAngle:0 endAngle:-M_PI clockwise:YES];
            
            // 线的特点
            nineLayer.path = ninePath.CGPath;
            nineLayer.strokeColor = [UIColor blackColor].CGColor;
            nineLayer.fillColor = [UIColor clearColor].CGColor;
            nineLayer.lineCap = kCALineCapButt;
            nineLayer.lineWidth = 1;
            [self.layer addSublayer:nineLayer];
            [self addAnimationOneOnLayer:nineLayer duration:1];
        }
            break;

    }
}

- (void)addAnimationOneOnLayer:(CAShapeLayer *)layer duration:(CFTimeInterval)duration
{
    CABasicAnimation *animation = [CABasicAnimation animationWithKeyPath:@"strokeEnd"];
    animation.fromValue = @(0);
    animation.toValue = @(1);
    animation.duration = duration;
    [layer addAnimation:animation forKey:nil];
}



@end
